diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/emlsr-manager.h ns-3.45/src/wifi/model/eht/emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/emlsr-manager.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/emlsr-manager.h	2025-06-01 20:34:45.615702200 -0700
@@ -82,9 +82,6 @@
     friend class ::EmlsrCcaBusyTest;
 
   public:
-    /// The aMediumSyncThreshold defined by Sec. 35.3.16.18.1 of 802.11be D4.0
-    static constexpr uint16_t MEDIUM_SYNC_THRESHOLD_USEC = 72;
-
     /**
      * @brief Get the type ID.
      * @return the object TypeId
@@ -234,11 +231,11 @@
     void NotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
 
     /**
-     * Notify the reception of an initial Control frame on the given link.
+     * Notify the start of a DL TXOP on the given link.
      *
-     * @param linkId the ID of the link on which the initial Control frame was received
+     * @param linkId the ID of the given link
      */
-    void NotifyIcfReceived(uint8_t linkId);
+    void NotifyDlTxopStart(uint8_t linkId);
 
     /**
      * Notify the start of an UL TXOP on the given link
@@ -270,12 +267,10 @@
      * Notify the end of a TXOP on the given link.
      *
      * @param linkId the ID of the given link
-     * @param ulTxopNotStarted whether this is a notification of the end of an UL TXOP that did
-     *                      not even start (no frame transmitted)
-     * @param ongoingDlTxop whether a DL TXOP is ongoing on the given link (if true, this is
-     *                      a notification of the end of an UL TXOP)
+     * @param edca the EDCAF that carried out the TXOP, in case of UL TXOP, or a null pointer,
+     *             in case of DL TXOP
      */
-    void NotifyTxopEnd(uint8_t linkId, bool ulTxopNotStarted = false, bool ongoingDlTxop = false);
+    void NotifyTxopEnd(uint8_t linkId, Ptr<QosTxop> edca = nullptr);
 
     /**
      * Notify that an STA affiliated with the EMLSR client is causing in-device interference
@@ -344,6 +339,16 @@
      */
     std::pair<bool, Time> CheckPossiblyReceivingIcf(uint8_t linkId) const;
 
+    /**
+     * This method is called when an aux PHY has completed reception of an ICF to determine whether
+     * there is any reason preventing the main PHY from switching link and be on the aux PHY link
+     * by the time the ICF reception is completed to take over the DL TXOP.
+     *
+     * @param linkId the ID of the link on which ICF has been received
+     * @return the reason, if any, preventing the main PHY from switching link
+     */
+    virtual std::optional<WifiIcfDrop> CheckMainPhyTakesOverDlTxop(uint8_t linkId) const;
+
   protected:
     void DoDispose() override;
 
@@ -398,8 +403,6 @@
      *
      * @param linkId the ID of the link on which the main PHY has to operate
      * @param noSwitchDelay whether switching delay should be zero
-     * @param resetBackoff whether backoff should be reset on the link on which the main PHY
-     *                     is operating
      * @param requestAccess whether channel access should be requested on the link on which the
      *                      main PHY is moving onto
      * @param traceInfo information to pass to the main PHY switch traced callback (the fromLinkId
@@ -407,12 +410,9 @@
      */
     void SwitchMainPhy(uint8_t linkId,
                        bool noSwitchDelay,
-                       bool resetBackoff,
                        bool requestAccess,
                        EmlsrMainPhySwitchTrace&& traceInfo);
 
-    static constexpr bool RESET_BACKOFF = true;       //!< reset backoff on main PHY switch
-    static constexpr bool DONT_RESET_BACKOFF = false; //!< do not reset backoff on main PHY switch
     static constexpr bool REQUEST_ACCESS = true; //!< request channel access when PHY switch ends
     static constexpr bool DONT_REQUEST_ACCESS =
         false; //!< do not request channel access when PHY switch ends
@@ -430,10 +430,11 @@
     /**
      * Callback connected to the EmlsrLinkSwitch trace source of StaWifiMac.
      *
-     * @param linkId the ID of the link involved in the EMLSR link switch event
-     * @param phy a pointer to the PHY involved in the EMLSR link switch event
+     * @param linkId the ID of the link which the PHY is connected to/disconnected from
+     * @param phy a pointer to the PHY that is connected to/disconnected from the given link
+     * @param connected true if the PHY is connected, false if the PHY is disconnected
      */
-    virtual void EmlsrLinkSwitchCallback(uint8_t linkId, Ptr<WifiPhy> phy);
+    virtual void EmlsrLinkSwitchCallback(uint8_t linkId, Ptr<WifiPhy> phy, bool connected);
 
     /**
      * Set the CCA ED threshold (if needed) on the given PHY that is switching channel to
@@ -498,23 +499,15 @@
      */
     void CancelAllSleepEvents();
 
-    /**
-     * Get whether channel access is expected to be granted on the given link within the given
-     * delay to an Access Category that has traffic to send on the given link.
-     *
-     * @param linkId the ID of the given link
-     * @param delay the given delay
-     * @return whether channel access is expected to be granted on the given link within the given
-     *         delay
-     */
-    bool GetExpectedAccessWithinDelay(uint8_t linkId, const Time& delay) const;
-
     /// Store information about a main PHY switch.
     struct MainPhySwitchInfo
     {
-        Time end;       //!< end of channel switching
-        uint8_t from{}; //!< ID of the link which the main PHY is/has been leaving
-        uint8_t to{};   //!< ID of the link which the main PHY is moving to
+        Time start;               //!< start of channel switching
+        bool disconnected{false}; //!< true if the main PHY is not connected to any link, i.e., it
+                                  //!< is switching or waiting to be connected to a link
+        uint8_t from{};           //!< ID of the link which the main PHY is/has been leaving
+        uint8_t to{};             //!< ID of the link which the main PHY is moving to
+        std::string reason;       //!< the reason for switching the main PHY
     };
 
     Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
@@ -584,7 +577,7 @@
      *
      * @param linkId the ID of the link on which the initial Control frame was received
      */
-    virtual void DoNotifyIcfReceived(uint8_t linkId) = 0;
+    virtual void DoNotifyDlTxopStart(uint8_t linkId) = 0;
 
     /**
      * Notify the subclass of the start of an UL TXOP on the given link
@@ -594,11 +587,21 @@
     virtual void DoNotifyUlTxopStart(uint8_t linkId) = 0;
 
     /**
+     * Notify the subclass that protection (if required) is completed and data frame exchange can
+     * start on the given link.
+     *
+     * @param linkId the ID of the given link
+     */
+    virtual void DoNotifyProtectionCompleted(uint8_t linkId) = 0;
+
+    /**
      * Notify the subclass of the end of a TXOP on the given link.
      *
      * @param linkId the ID of the given link
+     * @param edca the EDCAF that carried out the TXOP, in case of UL TXOP, or a null pointer,
+     *             in case of DL TXOP
      */
-    virtual void DoNotifyTxopEnd(uint8_t linkId) = 0;
+    virtual void DoNotifyTxopEnd(uint8_t linkId, Ptr<QosTxop> edca) = 0;
 
     /**
      * Notify the acknowledgment of the given MPDU.
@@ -723,61 +726,58 @@
 /**
  * Struct to trace that main PHY switched when a (DL or UL) TXOP ended.
  *
- * This trace is normally called when aux PHYs do not switch link and the main PHY switches back to
- * the preferred link when a TXOP carried out on another link ends. In such a case, the remTime
- * field is set to zero.
- *
- * Note that the main PHY may be already switching when the TXOP ends; this happens, e.g., when the
- * main PHY starts switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the
- * CTS is not received and the UL TXOP ends before the main PHY channel switch is completed. In this
- * case, the main PHY switch is postponed until the previous switch is completed and the remTime
- * field is set to the remaining channel switch delay at the time the TXOP ends:
+ * This trace is called when aux PHYs do not switch link and the main PHY switches back to the
+ * preferred link when a TXOP carried out on another link ends.
+ */
+struct EmlsrTxopEndedTrace : public EmlsrMainPhySwitchTraceImpl<EmlsrTxopEndedTrace>
+{
+    static constexpr std::string_view m_name = "TxopEnded"; //!< trace name
+};
+
+/**
+ * Struct to trace that main PHY started switching after a CTS timeout occurred on the link on
+ * which an RTS was transmitted to start an UL TXOP. Provides the time elapsed since the
+ * CTS timeout occurred.
  *
  *                                |-- main PHY switch --|
  *                                |----- to link 1 -----|
  *                                          ┌───────────┐
  *                                          │    CTS    │
  *  ────────────────────────┬───────────┬───┴X──────────┴─────────────────────────────
- *  [link 1]                │    RTS    │     │-remTime-│
- *                          └───────────┘     │         |-- main PHY switch --|
+ *  [link 1]                │    RTS    │     │-elapsed-│
+ *                          └───────────┘     │-- time--|-- main PHY switch --|
  *                                            │         |- to preferred link -|
- *                                         CTS timeout
+ *                                        CTS timeout
  *
- * Note also that the Advanced EMLSR manager may allow a main PHY switch to be interrupted. If this
- * option is enabled and the main PHY is switching when the TXOP ends, the previous switch is
- * interrupted and the main PHY starts switching to the preferred link (in this case, the remTime
- * field indicates the time that was left to complete the previous switch). Also note that, with
- * the Advanced EMLSR manager, this trace may also be called when aux PHYs switch link. This happens
- * when the TXOP ends while the main PHY is switching; in this case, the previous switch is
- * interrupted and the main PHY returns to the link on which it was operating before the previous
- * switch.
+ * Normally, this trace is called when aux PHYs do not switch links, because the main PHY has to
+ * return to the preferred link upon CTS timeout, because a TXOP did not start. In some cases, the
+ * main PHY may be switching when CTS timeout occurs; this happens when an aux PHY that is TX
+ * capable transmits an RTS and the main PHY starts switching to the aux PHY link (the start time
+ * of the main PHY switch is computed such that the main PHY switch ends slightly after the
+ * reception of the CTS). In such a case, the main PHY completes the current link switch and then
+ * it starts switching to return back to the preferred link.
  *
- *                                |-- main PHY switch --|
- *                                |----- to link 1 -----|(interrupted)
- *                                          ┌───────────┐
- *                                          │    CTS    │
- *  ────────────────────────┬───────────┬───┴X──────────┴─────────────────────────────
- *  [link 1]                │    RTS    │     │-remTime-│
- *                          └───────────┘     │-- main PHY switch --|
- *                                            │- to preferred link -|
- *                                         CTS timeout
+ * Note that the Advanced EMLSR manager may allow a main PHY switch to be interrupted. If this
+ * option is enabled and the main PHY is switching when CTS timeout occurs, the previous switch is
+ * interrupted and the main PHY starts switching to the previous link (in this case, the time
+ * elapsed since the CTS timeout occurred is zero). This holds true for both the case aux PHYs do
+ * not switch link and the case aux PHYs switch link.
  */
-struct EmlsrTxopEndedTrace : public EmlsrMainPhySwitchTraceImpl<EmlsrTxopEndedTrace>
+struct EmlsrCtsAfterRtsTimeoutTrace
+    : public EmlsrMainPhySwitchTraceImpl<EmlsrCtsAfterRtsTimeoutTrace>
 {
-    static constexpr std::string_view m_name = "TxopEnded"; //!< trace name
+    static constexpr std::string_view m_name = "CtsAfterRtsTimeout"; //!< trace name
 
-    Time remTime; //!< the remaining time (at TXOP end) until the main PHY completes the
-                  //!< channel switch, in case the main PHY is completing a previous switch
-                  //!< when the TXOP ends
+    Time sinceCtsTimeout; //!< time elapsed since CTS timeout occurred
 
     /**
      * Constructor provided because this struct is not an aggregate (it has a base struct), hence
      * we cannot use designated initializers.
      *
-     * @param t the value for the sinceTxopEnd field
+     * @param elapsed the value for the sinceCtsTimeout field
      */
-    EmlsrTxopEndedTrace(const Time& t)
-        : remTime(t)
+    EmlsrCtsAfterRtsTimeoutTrace(const Time& elapsed)
+        : sinceCtsTimeout(elapsed)
     {
     }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/multi-link-element.cc ns-3.45/src/wifi/model/eht/multi-link-element.cc
--- ns-3.44/src/wifi/model/eht/multi-link-element.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/multi-link-element.cc	2025-06-01 20:34:45.615702200 -0700
@@ -677,6 +677,23 @@
 }
 
 void
+MultiLinkElement::PerStaProfileSubelement::Print(std::ostream& os) const
+{
+    os << "Per-STA Profile Subelement=[";
+    os << "Variant: " << +static_cast<uint8_t>(m_variant);
+    os << ", STA Control: " << +m_staControl;
+    if (HasStaMacAddress())
+    {
+        os << ", STA MAC Address: " << m_staMacAddress;
+    }
+    if (m_bssParamsChgCnt)
+    {
+        os << ", BSS Params Change Count: " << +m_bssParamsChgCnt.value();
+    }
+    os << "]";
+}
+
+void
 MultiLinkElement::AddPerStaProfileSubelement()
 {
     auto variant = GetVariant();
@@ -808,4 +825,15 @@
     return count;
 }
 
+void
+MultiLinkElement::Print(std::ostream& os) const
+{
+    os << "Multi-Link Element=[Per-STA Profile Subelements: {";
+    for (const auto& subelement : m_perStaProfileSubelements)
+    {
+        subelement.Print(os);
+    }
+    os << "}]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/multi-link-element.h ns-3.45/src/wifi/model/eht/multi-link-element.h
--- ns-3.44/src/wifi/model/eht/multi-link-element.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/multi-link-element.h	2025-06-01 20:34:45.615702200 -0700
@@ -98,6 +98,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Get the Multi-Link element variant
@@ -306,6 +307,7 @@
         PerStaProfileSubelement& operator=(PerStaProfileSubelement&& perStaProfile) = default;
 
         WifiInformationElementId ElementId() const override;
+        void Print(std::ostream& os) const override;
 
         /**
          * Set the Link ID subfield in the STA Control field
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.cc ns-3.45/src/wifi/model/eht/tid-to-link-mapping-element.cc
--- ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/tid-to-link-mapping-element.cc	2025-06-01 20:34:45.615702200 -0700
@@ -291,4 +291,34 @@
     return count;
 }
 
+void
+TidToLinkMapping::Print(std::ostream& os) const
+{
+    os << "TID-To-Link Mapping=["
+       << "Direction: " << static_cast<uint16_t>(m_control.direction)
+       << ", Default Mapping: " << m_control.defaultMapping
+       << ", Link Mapping Size: " << +m_control.linkMappingSize;
+    if (m_control.mappingSwitchTimePresent)
+    {
+        os << ", Mapping Switch Time: " << *m_mappingSwitchTime;
+    }
+    if (m_control.expectedDurationPresent)
+    {
+        os << ", Expected Duration: " << *m_expectedDuration;
+    }
+    os << ", Link Mapping: {";
+    for (const auto& [tid, linkMapping] : m_linkMapping)
+    {
+        os << "TID " << +tid << ": ";
+        for (uint8_t linkId = 0; linkId < 15; linkId++)
+        {
+            if (((linkMapping >> linkId) & 0x0001) == 1)
+            {
+                os << +linkId << " ";
+            }
+        }
+    }
+    os << "}]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.h ns-3.45/src/wifi/model/eht/tid-to-link-mapping-element.h
--- ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/tid-to-link-mapping-element.h	2025-06-01 20:34:45.615702200 -0700
@@ -132,6 +132,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/extended-capabilities.cc ns-3.45/src/wifi/model/extended-capabilities.cc
--- ns-3.44/src/wifi/model/extended-capabilities.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/extended-capabilities.cc	2025-06-01 20:34:45.615702200 -0700
@@ -20,7 +20,7 @@
 void
 ExtendedCapabilities::Print(std::ostream& os) const
 {
-    os << "Extended Capabilities=";
+    os << "Extended Capabilities=[]";
     // TODO: print useful capabilities
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/extended-capabilities.h ns-3.45/src/wifi/model/extended-capabilities.h
--- ns-3.44/src/wifi/model/extended-capabilities.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/extended-capabilities.h	2025-06-01 20:34:45.615702200 -0700
@@ -18,7 +18,7 @@
  * @brief The Extended Capabilities Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the Extended Capabilities Information Element
+ * This class knows how to serialize and deserialize the Extended Capabilities Information Element
  */
 class ExtendedCapabilities : public WifiInformationElement
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/frame-exchange-manager.cc ns-3.45/src/wifi/model/frame-exchange-manager.cc
--- ns-3.44/src/wifi/model/frame-exchange-manager.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/frame-exchange-manager.cc	2025-06-01 20:34:45.616702300 -0700
@@ -322,6 +322,7 @@
 {
     NS_LOG_FUNCTION(this << macHdr << txVector << psduDuration.As(Time::MS));
     m_ongoingRxInfo = {macHdr, txVector, Simulator::Now() + psduDuration};
+    UpdateNav(macHdr, txVector, psduDuration);
 }
 
 std::optional<std::reference_wrapper<const FrameExchangeManager::OngoingRxInfo>>
@@ -612,14 +613,8 @@
     auto psdu = Create<WifiPsdu>(mpdu, false);
     FinalizeMacHeader(psdu);
     m_allowedWidth = std::min(m_allowedWidth, txVector.GetChannelWidth());
-    auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
-    // The TXNAV timer is a single timer, shared by the EDCAFs within a STA, that is initialized
-    // with the duration from the Duration/ID field in the frame most recently successfully
-    // transmitted by the TXOP holder, except for PS-Poll frames. (Sec.10.23.2.2 IEEE 802.11-2020)
-    if (!mpdu->GetHeader().IsPsPoll())
-    {
-        m_txNav = Max(m_txNav, Simulator::Now() + txDuration + mpdu->GetHeader().GetDuration());
-    }
+    const auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
+    SetTxNav(mpdu, txDuration);
     m_phy->Send(psdu, txVector);
 }
 
@@ -871,13 +866,13 @@
 
 void
 FrameExchangeManager::SendCtsAfterRts(const WifiMacHeader& rtsHdr,
-                                      WifiMode rtsTxMode,
+                                      const WifiTxVector& rtsTxVector,
                                       double rtsSnr)
 {
-    NS_LOG_FUNCTION(this << rtsHdr << rtsTxMode << rtsSnr);
+    NS_LOG_FUNCTION(this << rtsHdr << rtsTxVector << rtsSnr);
 
     WifiTxVector ctsTxVector =
-        GetWifiRemoteStationManager()->GetCtsTxVector(rtsHdr.GetAddr2(), rtsTxMode);
+        GetWifiRemoteStationManager()->GetCtsTxVector(rtsHdr.GetAddr2(), rtsTxVector.GetMode());
     DoSendCtsAfterRts(rtsHdr, ctsTxVector, rtsSnr);
 }
 
@@ -1018,11 +1013,11 @@
         m_dcf->UpdateFailedCw(m_linkId);
     }
     m_sentFrameTo.clear();
+    // reset TXNAV because transmission failed
+    ResetTxNav();
     // A non-QoS station always releases the channel upon a transmission failure
     NotifyChannelReleased(m_dcf);
     m_dcf = nullptr;
-    // reset TXNAV because transmission failed
-    m_txNav = Simulator::Now();
 }
 
 void
@@ -1089,38 +1084,50 @@
 {
     NS_LOG_FUNCTION(this << *rts << txVector);
 
-    DoCtsTimeout(Create<WifiPsdu>(m_mpdu, true));
+    DoCtsTimeout(WifiPsduMap{{SU_STA_ID, Create<WifiPsdu>(m_mpdu, true)}});
     m_mpdu = nullptr;
 }
 
 void
-FrameExchangeManager::DoCtsTimeout(Ptr<WifiPsdu> psdu)
+FrameExchangeManager::DoCtsTimeout(const WifiPsduMap& psduMap)
 {
-    NS_LOG_FUNCTION(this << *psdu);
+    NS_LOG_FUNCTION(this << psduMap);
 
-    // GetUpdateCwOnCtsTimeout() needs to be called before resetting m_sentRtsTo
+    // these functions need to be called before resetting m_sentRtsTo
     const auto updateCw = GetUpdateCwOnCtsTimeout();
+    const auto reportRts = GetReportRtsFailed();
 
     m_sentRtsTo.clear();
-    for (const auto& mpdu : *PeekPointer(psdu))
+    for (const auto& [staId, psdu] : psduMap)
     {
-        if (mpdu->IsQueued())
+        for (const auto& mpdu : *PeekPointer(psdu))
         {
-            mpdu->ResetInFlight(m_linkId);
+            if (mpdu->IsQueued())
+            {
+                mpdu->ResetInFlight(m_linkId);
+            }
         }
-    }
 
-    GetWifiRemoteStationManager()->ReportRtsFailed(psdu->GetHeader(0));
-    if (auto droppedMpdu = DropMpduIfRetryLimitReached(psdu))
-    {
-        GetWifiRemoteStationManager()->ReportFinalRtsFailed(droppedMpdu->GetHeader());
-    }
+        if (const auto& hdr = psdu->GetHeader(0);
+            !GetIndividuallyAddressedRecipient(m_mac, hdr).IsGroup())
+        {
+            if (reportRts)
+            {
+                GetWifiRemoteStationManager()->ReportRtsFailed(hdr);
+            }
+
+            if (auto droppedMpdu = DropMpduIfRetryLimitReached(psdu))
+            {
+                GetWifiRemoteStationManager()->ReportFinalRtsFailed(droppedMpdu->GetHeader());
+            }
+        }
 
-    // Make the sequence numbers of the MPDUs available again if the MPDUs have never
-    // been transmitted, both in case the MPDUs have been discarded and in case the
-    // MPDUs have to be transmitted (because a new sequence number is assigned to
-    // MPDUs that have never been transmitted and are selected for transmission)
-    ReleaseSequenceNumbers(psdu);
+        // Make the sequence numbers of the MPDUs available again if the MPDUs have never
+        // been transmitted, both in case the MPDUs have been discarded and in case the
+        // MPDUs have to be transmitted (because a new sequence number is assigned to
+        // MPDUs that have never been transmitted and are selected for transmission)
+        ReleaseSequenceNumbers(psdu);
+    }
 
     TransmissionFailed(!updateCw);
 }
@@ -1131,6 +1138,12 @@
     return true;
 }
 
+bool
+FrameExchangeManager::GetReportRtsFailed() const
+{
+    return true;
+}
+
 void
 FrameExchangeManager::ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const
 {
@@ -1243,11 +1256,9 @@
             // has been correctly received)
             NS_ASSERT(perMpduStatus.empty() || (perMpduStatus.size() == 1 && perMpduStatus[0]));
             // Ack and CTS do not carry Addr2
-            if (!psdu->GetHeader(0).IsAck() && !psdu->GetHeader(0).IsCts())
+            if (const auto& hdr = psdu->GetHeader(0); !hdr.IsAck() && !hdr.IsCts())
             {
-                GetWifiRemoteStationManager()->ReportRxOk(psdu->GetHeader(0).GetAddr2(),
-                                                          rxSignalInfo,
-                                                          txVector);
+                GetWifiRemoteStationManager()->ReportRxOk(psdu->GetAddr2(), rxSignalInfo, txVector);
             }
             ReceiveMpdu(*(psdu->begin()), rxSignalInfo, txVector, perMpduStatus.empty());
         }
@@ -1285,23 +1296,26 @@
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
-    UpdateNav(psdu, txVector);
+    UpdateNav(psdu->GetHeader(0), txVector);
 }
 
 void
-FrameExchangeManager::UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+FrameExchangeManager::UpdateNav(const WifiMacHeader& hdr,
+                                const WifiTxVector& txVector,
+                                const Time& surplus)
 {
-    NS_LOG_FUNCTION(this << psdu << txVector);
+    NS_LOG_FUNCTION(this << hdr << txVector << surplus.As(Time::US));
 
-    if (!psdu->HasNav())
+    if (!hdr.HasNav())
     {
         return;
     }
 
-    Time duration = psdu->GetDuration();
+    Time duration = hdr.GetDuration();
     NS_LOG_DEBUG("Duration/ID=" << duration);
+    duration += surplus;
 
-    if (psdu->GetAddr1() == m_self)
+    if (hdr.GetAddr1() == m_self)
     {
         // When the received frame's RA is equal to the STA's own MAC address, the STA
         // shall not update its NAV (IEEE 802.11-2016, sec. 10.3.2.4)
@@ -1325,14 +1339,16 @@
         // The “CTS_Time” shall be calculated using the length of the CTS frame and the data
         // rate at which the RTS frame used for the most recent NAV update was received
         // (IEEE 802.11-2016 sec. 10.3.2.4)
-        if (psdu->GetHeader(0).IsRts())
+        if (hdr.IsRts())
         {
+            auto addr2 = hdr.GetAddr2();
             WifiTxVector ctsTxVector =
-                GetWifiRemoteStationManager()->GetCtsTxVector(psdu->GetAddr2(), txVector.GetMode());
+                GetWifiRemoteStationManager()->GetCtsTxVector(addr2, txVector.GetMode());
             Time navResetDelay =
                 2 * m_phy->GetSifs() +
                 WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
                 WifiPhy::CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
+            m_navResetEvent.Cancel();
             m_navResetEvent =
                 Simulator::Schedule(navResetDelay, &FrameExchangeManager::NavResetTimeout, this);
         }
@@ -1350,6 +1366,29 @@
     m_channelAccessManager->NotifyNavResetNow(Seconds(0));
 }
 
+void
+FrameExchangeManager::SetTxNav(Ptr<const WifiMpdu> mpdu, const Time& txDuration)
+{
+    // The TXNAV timer is a single timer, shared by the EDCAFs within a STA, that is initialized
+    // with the duration from the Duration/ID field in the frame most recently successfully
+    // transmitted by the TXOP holder, except for PS-Poll frames. The TXNAV timer begins counting
+    // down from the end of the transmission of the PPDU containing that frame.
+    // (Sec.10.23.2.2 IEEE 802.11-2020)
+    if (!mpdu->GetHeader().IsPsPoll())
+    {
+        const auto txNav = Simulator::Now() + txDuration + mpdu->GetHeader().GetDuration();
+        NS_LOG_DEBUG("Setting TXNAV to " << txNav.As(Time::S));
+        m_txNav = Max(m_txNav, txNav);
+    }
+}
+
+void
+FrameExchangeManager::ResetTxNav()
+{
+    NS_LOG_FUNCTION(this);
+    m_txNav = Simulator::Now();
+}
+
 bool
 FrameExchangeManager::VirtualCsMediumIdle() const
 {
@@ -1386,7 +1425,7 @@
                                                      &FrameExchangeManager::SendCtsAfterRts,
                                                      this,
                                                      hdr,
-                                                     txVector.GetMode(),
+                                                     txVector,
                                                      rxSnr);
             }
             else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/frame-exchange-manager.h ns-3.45/src/wifi/model/frame-exchange-manager.h
--- ns-3.44/src/wifi/model/frame-exchange-manager.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/frame-exchange-manager.h	2025-06-01 20:34:45.616702300 -0700
@@ -353,12 +353,17 @@
     virtual void ProtectionCompleted();
 
     /**
-     * Update the NAV, if needed, based on the Duration/ID of the given <i>psdu</i>.
+     * Update the NAV, if needed, based on the Duration/ID of the given MAC header and the given
+     * surplus.
      *
-     * @param psdu the received PSDU
-     * @param txVector TxVector of the received PSDU
-     */
-    virtual void UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+     * @param hdr the given MAC header
+     * @param txVector TxVector of the PSDU containing the MAC header
+     * @param surplus the surplus to add to the Duration/ID value. This is needed, e.g., when
+     *                setting the NAV at the end of the reception of the MAC header
+     */
+    virtual void UpdateNav(const WifiMacHeader& hdr,
+                           const WifiTxVector& txVector,
+                           const Time& surplus = Time{0});
 
     /**
      * Reset the NAV upon expiration of the NAV reset timer.
@@ -366,6 +371,17 @@
     virtual void NavResetTimeout();
 
     /**
+     * Set the TXNAV upon sending an MPDU.
+     *
+     * @param mpdu the MPDU being sent
+     * @param txDuration the TX duration of the MPDU
+     */
+    void SetTxNav(Ptr<const WifiMpdu> mpdu, const Time& txDuration);
+
+    /// Reset the TXNAV
+    void ResetTxNav();
+
+    /**
      * This method is called when the reception of a PSDU fails.
      *
      * @param psdu the PSDU whose reception failed
@@ -595,10 +611,12 @@
      * Send CTS after receiving RTS.
      *
      * @param rtsHdr the header of the received RTS
-     * @param rtsTxMode the TX mode used to transmit the RTS
+     * @param rtsTxVector the TXVECTOR used to transmit the RTS
      * @param rtsSnr the SNR of the RTS in linear scale
      */
-    virtual void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr);
+    virtual void SendCtsAfterRts(const WifiMacHeader& rtsHdr,
+                                 const WifiTxVector& rtsTxVector,
+                                 double rtsSnr);
 
     /**
      * Send CTS after receiving RTS.
@@ -688,12 +706,12 @@
      */
     virtual void CtsTimeout(Ptr<WifiMpdu> rts, const WifiTxVector& txVector);
     /**
-     * Take required actions when the CTS timer fired after sending an RTS to
-     * protect the given PSDU expires.
+     * Take required actions when the CTS timer fired after sending an (MU-)RTS to
+     * protect the given PSDU map expires.
      *
-     * @param psdu the PSDU protected by the failed RTS
+     * @param psduMap the PSDU map protected by the failed (MU-)RTS
      */
-    void DoCtsTimeout(Ptr<WifiPsdu> psdu);
+    void DoCtsTimeout(const WifiPsduMap& psduMap);
 
     /**
      * @return whether CW shall be updated on CTS timeout
@@ -701,6 +719,11 @@
     virtual bool GetUpdateCwOnCtsTimeout() const;
 
     /**
+     * @return whether an (MU-)RTS failure shall be reported to the remote station manager
+     */
+    virtual bool GetReportRtsFailed() const;
+
+    /**
      * Reset this frame exchange manager.
      */
     virtual void Reset();
